Leetcode 300. Longest Increasing Subsequence

2018-01-12 14:26:35 浏览数 (1)

Given an unsorted array of integers, find the length of longest increasing subsequence.

For example, Given [10, 9, 2, 5, 3, 7, 101, 18], The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

最长上升子序列。dp 二分。

dp[i]表示长度为i的序列最后一位是多少。

代码语言:javascript复制
class Solution {
public:
    int lengthOfLIS(vector<int>& nums) {
        vector<int> res;
        for(auto i : nums)
        {
            auto tmp = lower_bound(res.begin(), res.end(), i);
            if(tmp == res.end()) res.push_back(i);
            else *tmp = i;
        }
        return res.size();
    }
};

0 人点赞